DECLARE FUNCTION Pass6! (p1 as DOUBLE, p2 as DOUBLE, p3 as DOUBLE, p4 as DOUBLE, p5 as DOUBLE, p6 as DOUBLE)
DECLARE FUNCTION PassRef!(p() as DOUBLE)
'-------------------------------- Function04 -----------------------------'
'                                                                         '
'	This function compares passing the individual members		  '
'	of an array vs. passing a single reference to the array.	  '
'	No work is done in the functions, since the passing is		  '
'	being explored.                                     		  '
'                                                                         '
'-------------------------------------------------------------------------'

' global declarations
'longs
DIM counter     AS LONG         'iteration counter
DIM NumIts      AS LONG         'number of iterations

'singles
DIM starttimer  AS SINGLE       'ticks at start of loop
DIM stoptimer   AS SINGLE       'ticks at loop exit

'doubles
Dim	E 	AS DOUBLE	'return value for function calls
Dim	X(6)	AS DOUBLE	'array to pass to function

'-------------------------------- Initializations ------------------------

'clear the screen
CLS

'initialize the iteration counter
NumIts = 100000000

'initialize array with some values for demo
x(1) = 1.234!
x(2) = 2.765!
x(3) = 3.718!
x(4) = 9.234!
x(5) = 0.003!
x(6) = -5.443!


'-------------------------------- Pass Array Elements --------------------

'display message
PRINT "Passing 6 DOUBLES to function ..."
PRINT

'start the timer
starttimer = TIMER

FOR counter = 1 TO NumIts

	'call the function
	E = Pass6(x(1), x(2), x(3), x(4), x(5), x(6))

NEXT counter

'stop the timer
stoptimer = TIMER

'display the result
PRINT "Called function with 6 DOUBLEs "; NumIts; " times in: "; stoptimer - starttimer; " seconds"
PRINT
'--------------------------- End Pass Array Elements -----------------------

'------------------------------ Pass Array Pointer -------------------------

'display message
PRINT "Passing Array Pointer to function ..."
PRINT

'start the timer
starttimer = TIMER

FOR counter = 1 TO NumIts

	'call the function
	E = PassRef(x)

NEXT counter

'stop the timer
stoptimer = TIMER

'display the result
PRINT "Called function with array pointer "; NumIts; " times in: "; stoptimer - starttimer; " seconds"
PRINT

'-------------------------- End Pass Array Pointer -------------------------

' Keep display active until user presses a key
' this is needed when running in the dos subsystem of windows, else
' windows closes window immediately

' display a message
PRINT : PRINT "Press any key to end..."

'check keylatch; if empty, simply loop back
LoopHere:
A$ = INKEY$
IF A$ = "" THEN GOTO LoopHere

'end when keylatch contains any key
END

FUNCTION Pass6(p1 as DOUBLE, p2 as DOUBLE, p3 as DOUBLE, p4 as DOUBLE, p5 as DOUBLE, p6 as DOUBLE)


	'return a value
	Pass6 = 10.456!


END FUNCTION

FUNCTION PassRef(p() as DOUBLE)

	'return a value
	PassRef = 10.456!

END FUNCTION

