'-------------------------------- Function07 -----------------------------'
'                                                                         '
'       This program compares a the rnd() function to an inline pseudo	  '
'	random number generator.					  '
'                                                                         '
'-------------------------------------------------------------------------'

' global declarations
'longs
DIM counter     AS LONG         'iteration counter
DIM NumIts      AS LONG         'number of iterations
Dim m		AS LONG		'generator period
Dim a		AS LONG		'generator definition factor
DIM x		AS LONG		''current' number in sequence
DIM xk		AS LONG		''last' number in sequence

'singles
DIM starttimer  AS SINGLE       'ticks at start of loop
DIM stoptimer   AS SINGLE       'ticks at loop exit
DIM r		AS SINGLE	'computed random number
dim m1		AS Single	'1/m

'doubles
DIM Fact 	AS Double	'computed factorial

'clear the screen
CLS

'initialize the iteration counter
NumIts = 50000000


'--------------------------- RND() Function --------------------------------

'display message
PRINT "Computing random numbers via rnd() function ..."
PRINT

'start the timer
starttimer = TIMER

FOR counter = 1 TO NumIts

	'call the function
	r = rnd

NEXT counter

'stop the timer
stoptimer = TIMER

'display the result
PRINT "Called rnd "; NumIts; " times in: "; stoptimer - starttimer; " seconds"
PRINT

'------------------------- End RND() Function ------------------------------

'---------------------- Inline Random Number Generator ---------------------

'display message
PRINT "Computing random numbers using INLINE code ..."
PRINT

'start the timer
starttimer = TIMER

'initialize the number generator
a = 25
m = 16777216
x = 200

'also need 1/m to get value 0-1
m1 = 5.9e-8

FOR counter = 1 TO NumIts

	'get next number in sequence
	xk = (a * x) mod m

	'convert to value 0-1
	r = xk * m1

	'store this number as 'last'
	x = xk
        

NEXT counter

'stop the timer
stoptimer = TIMER

'display the result
PRINT "Computed "; NumIts; " random numbers using inline code in: "; stoptimer - starttimer; " seconds"
PRINT

'------------------ End Inline Random Number Generator ---------------------

' Keep display active until user presses a key
' this is needed when running in the dos subsystem of windows, else
' windows closes window immediately

' display a message
PRINT : PRINT "Press any key to end..."

'check keylatch; if empty, simply loop back
LoopHere:
A$ = INKEY$
IF A$ = "" THEN GOTO LoopHere

'end when keylatch contains any key
END