'-------------------------------- Loop02 ---------------------------------'
'                                                                         '
' This program compares a 3-d vector dot product via a rolled loop        '
' to one with an unrolled loop.                                           '
'                                                                         '
'-------------------------------------------------------------------------'

'global declarations
'longs
DIM counter     AS LONG         'iteration counter
DIM dotindex    AS LONG         'array index

'singles
DIM timestart   AS SINGLE       'ticks at start of loop
DIM timestop    AS SINGLE       'ticks at loop exit
DIM A(3)        AS SINGLE       'vector A
DIM B(3)        AS SINGLE       'vector B
DIM C           AS SINGLE       'dot product result

'initialize vectors A and B with some made-up values for demo
    A(0) = 3        'store dimensionality in 0th entry
    B(0) = 3

    A(1) = 23.45
    A(2) = 14.65
    A(3) = 33.87
    
    B(1) = 36.99
    B(2) = 21.32
    B(3) = 17.38
 


'clear the screen
CLS

'set exonential factor to a made-up value for demo
expvalu = 3.13

'-------------------------------- Rolled Loop Calculation -----------------

'display message
PRINT "Starting dot product with rolled loop ..."
PRINT

'start the timer
timestart = TIMER

'begin the rolled calculation
FOR counter = 1 TO 10000000

	'clear the dot product
	C = 0

	'dot product in rolled loop
	'could use A(0) here, in a generalized loop
	FOR dotindex = 1 TO 3

		C = C + A(dotindex) * B(dotindex)

	NEXT dotindex

NEXT counter

'stop the timer
timestop = TIMER

'display the result
PRINT "Dot Product with rolled loop in "; timestop - timestart; " seconds"
PRINT

'--------------------------------- End Rolled Loop Calculation -------------

'--------------------------------- Unrolled Loop Calculation ---------------

'display message
PRINT "Starting dot product with unrolled loop ..."
PRINT

'start the timer
timestart = TIMER

'begin the unrolled calculation
FOR counter = 1 TO 10000000

	C = A(1) * B(1) + A(2) * B(2) + A(3) * B(3)

NEXT counter

'stop the timer
timestop = TIMER

'display the result
PRINT "Dot Product with unrolled loop in "; timestop - timestart; " seconds"
PRINT

'------------------------------------- End Unrolled Loop Calculation --------

' Keep display active until user presses a key
' this is needed when running in the dos subsystem of windows, else
' windows closes window immediately

' display a message
PRINT : PRINT "Press any key to end..."

'check keylatch; if empty, simply loop back
LoopHere:
In$ = INKEY$
IF In$ = "" THEN GOTO LoopHere

'end when keylatch contains any key
END

