'-------------------------------- Other02 --------------------------------'
'                                                                         '
' This program compares a traditional if...then...else if...end if        '
' decision structure to the use of bit flag encoding use an OR operation. '                           
'                                                                         '
' NOTE: Due to array size limitations, the loops in this demo are only    '
'       30000 iterations.  Therefore, the demo is very short, and may     '
'       not be as 'dramatic' as the Windows Basic or C versions.          '
'       An extra interation loop was added to increase the run time       '
'                                                                         '
'-------------------------------------------------------------------------'

'global declarations
'longs
DIM rannum(30000) AS INTEGER       'random number sequence
				'used so that both decision routines
				'follow the same sequence
DIM counter     AS LONG         'iteration counter
DIM typeval     AS LONG         'the 'assigned' energy type
DIM itcounter   AS LONG         'outer iteration counter

'singles
DIM timestart   AS SINGLE       'ticks at start of loop
DIM timestop    AS SINGLE       'ticks at loop exit


'clear the screen
CLS

'---------------------------- Assign Random Number Array ------------------

DIM randval AS LONG         'random number
    
FOR counter = 1 TO 30000
    
	'get a random integer particle type: 1, 2 or 3
	randval = INT(3 * RND) + 1
	
	'assign random array according binary flags
	'assignment made as value = 2^(particle type-1)
	IF randval = 1 THEN

		rannum(counter) = 1

	ELSEIF ranval = 2 THEN

		rannum(counter) = 2

	ELSEIF ranval = 3 THEN

		rannum(counter) = 4

	END IF
    
    
NEXT counter
 

'-------------------------------- If..Then Decision -----------------------

'display message
PRINT "Assigning Energy Parameters using If...Then Decision ..."
PRINT

'start the timer
timestart = TIMER

FOR itcounter = 1 TO 10

FOR counter = 2 TO 30000

	'assign via If/ElseIf
	IF rannum(IFcounter) = 1 AND rannum(1) = 1 THEN
	    typevalue = 1
	ELSEIF rannum(IFcounter) = 2 AND rannum(1) = 1 THEN
	    typevalue = 3
	ELSEIF rannum(IFcounter) = 4 AND rannum(1) = 1 THEN
	    typevalue = 5
	ELSEIF rannum(IFcounter) = 1 AND rannum(1) = 2 THEN
	    typevalue = 3
	ELSEIF rannum(IFcounter) = 2 AND rannum(1) = 2 THEN
	    typevalue = 2
	ELSEIF rannum(IFcounter) = 4 AND rannum(1) = 2 THEN
	    typevalue = 6
	ELSEIF rannum(IFcounter) = 1 AND rannum(1) = 4 THEN
	    typevalue = 5
	ELSEIF rannum(IFcounter) = 2 AND rannum(1) = 4 THEN
	    typevalue = 6
	ELSEIF rannum(IFcounter) = 4 AND rannum(1) = 4 THEN
	    typevalue = 4
	END IF
NEXT counter

NEXT itcounter

'stop the timer
timestop = TIMER

'display the result
PRINT "300000 If...Then Decisions in "; timestop - timestart; " seconds"
PRINT

'--------------------------------- End If...Then Decision ------------------

'--------------------------------- Flag Encoded Decision -------------------

'display message
PRINT "Assigning Energy Parameters using flag encoding ..."
PRINT

'start the timer
timestart = TIMER


FOR itcounter = 1 TO 10


FOR counter = 2 TO 30000

	'interaction type is ParticleType OR ParticleType
	typevalue = rannum(counter) OR rannum(1)
 
NEXT counter

NEXT itcounter

'stop the timer
timestop = TIMER

'display the result
PRINT "300000 Flag Encoded 'Decisions' in "; timestop - timestart; " seconds"
PRINT

'----------------------------- End Flag Encoded Decision -------------------

' Keep display active until user presses a key
' this is needed when running in the dos subsystem of windows, else
' windows closes window immediately

' display a message
PRINT : PRINT "Press any key to end..."

'check keylatch; if empty, simply loop back
LoopHere:
A$ = INKEY$
IF A$ = "" THEN GOTO LoopHere

'end when keylatch contains any key
END

