VERSION 5.00
Begin VB.Form Data05 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Data05 - Local vs. Global Scope Demo"
   ClientHeight    =   3195
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4680
   Icon            =   "Data05.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdClear 
      Caption         =   "Clear Text"
      Height          =   615
      Left            =   3240
      TabIndex        =   2
      Top             =   1920
      Width           =   1335
   End
   Begin VB.CommandButton cmdGlobal 
      Caption         =   "Compute using Global Scope"
      Height          =   615
      Left            =   3240
      TabIndex        =   1
      Top             =   1080
      Width           =   1335
   End
   Begin VB.CommandButton cmdLocal 
      Caption         =   "Compute using Local Scope "
      Height          =   615
      Left            =   3240
      TabIndex        =   0
      Top             =   240
      Width           =   1335
   End
End
Attribute VB_Name = "Data05"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'This program demonstrates the performance difference between
'using global data vs. using local data.  This is not an
'endorsement of global data per se, since it has long been
'established that use of local variables result in more
'general funtions that are also more "bulletproof."
'
'However, the demo does show a few percent performance improvement
'with the use of globals.  Judicious and careful use of globals
'may help improve overall code performance.
'
'Note that the timer variables, each accessed only once per function,
'are globals in both cases.  Being outside the iterative loop,
'this can't be seen on the 0.01 second time scale used.

Option Explicit

'global declarations
'constants
Const cNumIts As Long = 50000000

'longs
Dim gCounter As Long

'singles
Dim starttimer As Single
Dim stoptimer As Single

'doubles
Dim gAngle As Double
Dim gResult As Double

'clears the print area for multiple runs
Private Sub cmdClear_Click()

    Cls

End Sub

'assigns an angle and computes sin(x) using only global data
Private Sub cmdGlobal_Click()

    'start the timer
    starttimer = Timer
    
    For gCounter = 1 To cNumIts
    
        'assign to global variable
        gAngle = Rnd()
        
        'compute sin using globals
        gResult = Sin(gAngle)
    
    Next gCounter

    'stop the timer
    stoptimer = Timer
    
    'display the result
    Print "Assigned angle and computed sin(x) using"
    Print "Global Data "; cNumIts; " times in"
    Print stoptimer - starttimer; " seconds."
    Print

End Sub

'assigns angle and computes sin(x) using local data
Private Sub cmdLocal_Click()

    'local declarations
    'longs
    Dim lCounter As Long
    
    'doubles
    Dim lAngle As Double
    Dim lResult As Double
    
    'start the timer
    starttimer = Timer
    
    For lCounter = 1 To cNumIts
    
        'assign to local variable
        lAngle = Rnd()
        
        'compute sin using locals
        lResult = Sin(lAngle)
    
    Next lCounter

    'stop the timer
    stoptimer = Timer
    
    'display the result
    Print "Assigned angle and computed sin(x) using"
    Print "Local Data "; cNumIts; " times in"
    Print stoptimer - starttimer; " seconds."
    Print

End Sub
