VERSION 5.00
Begin VB.Form frmLoop02 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Loop02 - Rolled and Unrolled Vector Dot Product"
   ClientHeight    =   3195
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4935
   Icon            =   "frmLoop02.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3195
   ScaleWidth      =   4935
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdClearText 
      Caption         =   "Clear Text"
      Height          =   615
      Left            =   3480
      TabIndex        =   2
      Top             =   2040
      Width           =   1095
   End
   Begin VB.CommandButton cmdUnrolled 
      Caption         =   "Unrolled Dot Product"
      Height          =   615
      Left            =   3480
      TabIndex        =   1
      Top             =   1200
      Width           =   1095
   End
   Begin VB.CommandButton cmdRolled 
      Caption         =   "Rolled Dot Product"
      Height          =   615
      Left            =   3480
      TabIndex        =   0
      Top             =   360
      Width           =   1095
   End
End
Attribute VB_Name = "frmLoop02"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'This program performs a vector dot product using
'the rolled and unrolled coding styles.
'
'The dot product is computed as
'
'       c = a(1)b(1) + a(2)b(2) + a(3)b(3)
'
'with the vectors A = (a(1),a(2),a(3)) and
'B = (b(1), b(2), b(3)).


Option Explicit

Const cNumIts As Long = 100000000   'number of times to perform the dot product

Dim StartTimer As Single    'system clicks at start of loop
Dim StopTimer As Single     'system clicks at loop exit

Dim A(3) As Single          'vector A
Dim B(3) As Single          'vector B
Dim C As Single             'the dot product

'Clears the screen between tests

Private Sub cmdClearText_Click()

    Cls

End Sub

'Inialization code...assigns values to the vectors
'A and B. The vectors are 'made-up.'
Private Sub Form_Load()

    A(0) = 3        'for future reference, stores
                    'stores the dimensionality

    A(1) = 23.45
    A(2) = 14.65
    A(3) = 33.87
    
    B(1) = 36.99
    B(2) = 21.32
    B(3) = 17.38
    

End Sub

'This routine computes the dot product
'of the vectors A and B using a rolled loop.
Private Sub cmdRolled_Click()

    Dim DotCounter As Long      'counter variable
    Dim ItCounter As Long       'counter variable
    
    StartTimer = Timer      'start the timer
    
    For ItCounter = 1 To cNumIts
    
        C = 0       'clears the dot variable
    
        For DotCounter = 1 To 3     'three dimensional vectors
    
            C = C + A(DotCounter) * B(DotCounter)   'running sum
    
        Next DotCounter
    
    Next ItCounter
        
    StopTimer = Timer   'stop the timer
    
    'Display the result
    Print "Performed the Rolled Dot Product "
    Print cNumIts; " times in "; StopTimer - StartTimer; " seconds."
    Print
    

End Sub

'This procedure computes the dot product of the vectors
'A and B using Unrolled Loop.  This routine is about
'3.4 times faster than the rolled version.

Private Sub cmdUnrolled_Click()

    Dim DotCounter As Long      'counter variable
    Dim ItCounter As Long       'counter variable
    
    StartTimer = Timer      'start the timer
    
    For ItCounter = 1 To cNumIts
    
        C = 0           'clear the dot product variable
    
        'compute the dot product directly, no looping
        C = A(1) * B(1) + A(2) * B(2) + A(3) * B(3)
    
    Next ItCounter
        
    StopTimer = Timer       'stop the timer
    
    'display the results
    Print "Performed the Unrolled Dot Product "
    Print cNumIts; " times in "; StopTimer - StartTimer; " seconds."
    Print


End Sub


