VERSION 5.00
Begin VB.Form frmRisc03 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "RISC03 - Combined r and LJ Energy, CISC vs. RISC"
   ClientHeight    =   2850
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5880
   Icon            =   "frmRisc03.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2850
   ScaleWidth      =   5880
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdClearText 
      Caption         =   "Clear Text"
      Height          =   615
      Left            =   3960
      TabIndex        =   2
      Top             =   1920
      Width           =   1695
   End
   Begin VB.CommandButton cmdRISC 
      Caption         =   "r and E as RISC"
      Height          =   615
      Left            =   3960
      TabIndex        =   1
      Top             =   1080
      Width           =   1695
   End
   Begin VB.CommandButton cmdCISC 
      Caption         =   "r and E as CISC"
      Height          =   615
      Left            =   3960
      TabIndex        =   0
      Top             =   240
      Width           =   1695
   End
End
Attribute VB_Name = "frmRisc03"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'This program demonstrates the use of the RISC style coding
'to compute both the 2d distance and the LJ Energy.

Option Explicit

'Global Declarations
'Constants
Const cNumIts As Long = 10000000    'number of iterations
Const x1 As Double = 1.234          'just some made up particle
Const x2 As Double = 2.678          'coordinates
Const y1 As Double = 0.345
Const y2 As Double = 1.529

'Singles
Dim starttimer As Single        'system ticks at start of loop
Dim stoptimer As Single         'system ticks at loop end

'Combine the CISC styles from RISC01 and RISC02 examples
'r and Energy are computed in the Scientist Style;
'no advanced optimizations are employed
Private Sub cmdCISC_Click()

    'Local Declarations
    'Longs
    Dim counter As Long     'iteration counter

    'Doubles
    Dim r As Double         'computed 2d distance
    Dim Energy As Double    'computed Energy

    starttimer = Timer      'start the timer
    
    For counter = 1 To cNumIts
    
        'compute r in Scientist Style
        r = Sqr((x1 - x2) ^ 2 + (y1 - y2) ^ 2)
        
        'Compute LJ Energy in Scientist Style
        Energy = 1 / r ^ 12 - 1 / r ^ 6
    
    Next counter
    
    stoptimer = Timer       'stop the timer
    
    'Display the results
    Print
    Print "Computed r and E "; cNumIts; " times as CISC in"
    Print stoptimer - starttimer; " seconds"
    Print "E = "; Energy

End Sub

'Clears the output for multiple tests

Private Sub cmdClearText_Click()

    Cls

End Sub

'Combine the RISC01 and RISC02 calculations
Private Sub cmdRISC_Click()
    
    'Local Declarations
    'Longs
    Dim counter As Long         'iteration counter
    
    'Doubles
    Dim TempX As Double         'holder for (x2-x1)^2
    Dim TempY As Double         'holder for (y2-y1)^2
    Dim r As Double             'computed 2d distance
    Dim r1 As Double            'holder for r^6
    Dim r2 As Double            'holder for r^12
    Dim Energy As Double        'computed energy
    
    starttimer = Timer      'start the timer
    
    For counter = 1 To cNumIts
    
        'compute r without the ^2 operation
        TempX = x1 - x2
        TempX = TempX * TempX
        TempY = y1 - y2
        TempY = TempY * TempY
        TempY = TempY + TempX
        
        r = Sqr(TempY)
        
        'compute E without the ^6 and ^12 operations
        r1 = r * r * r * r * r * r
        r2 = r1 * r1
        
        Energy = 1 / r2 - 1 / r1
        
    Next counter
    
    stoptimer = Timer       'stop the timer
    
    Print
    Print "Computed r and E "; cNumIts; " times as RISC in"
    Print stoptimer - starttimer; " seconds"
    Print "E = "; Energy
    
End Sub
