VERSION 5.00
Begin VB.Form frmLookUp02 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "LookUP02 - LookUp Table for exponentiation function"
   ClientHeight    =   3435
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5415
   Icon            =   "frmLookUp02.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3435
   ScaleWidth      =   5415
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton Command1 
      Caption         =   "Initialize Look-Up Array"
      Height          =   615
      Left            =   3480
      TabIndex        =   3
      Top             =   120
      Width           =   1815
   End
   Begin VB.CommandButton cmdClearText 
      Caption         =   "Clear Text"
      Height          =   615
      Left            =   3480
      TabIndex        =   2
      Top             =   2640
      Width           =   1815
   End
   Begin VB.CommandButton cmdLookUp 
      Caption         =   "exp(-E/kT) by LookUp"
      Height          =   615
      Left            =   3480
      TabIndex        =   1
      Top             =   1800
      Width           =   1815
   End
   Begin VB.CommandButton cmdExplicit 
      Caption         =   "Explicitly Calc exp(-E/kT)"
      Height          =   615
      Left            =   3480
      TabIndex        =   0
      Top             =   960
      Width           =   1815
   End
End
Attribute VB_Name = "frmLookUp02"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'This program demonstrates the use of Look-Up tables for
'the computation of a Boltzmann factor,
'
'               P(E) = exp(-E/(kT))
'
'The Look-Up Table in this demo is an array

Option Explicit

'Global Declarations
'longs
Const cNumIts As Long = 10000000        'number of iterations

'Singles
Dim Starttimer As Single        'ticks at start of loop
Dim Stoptimer As Single         'ticks at loop exit

'Doubles
Const kvar As Double = 1.381E-23  'Boltzmann's Constant
Dim Temp As Double              'Temperature
Dim Energy As Double            'Energy
Dim Expon(10000) As Double      'Boltzman factor function, P(Energy)

'clear the display area
Private Sub cmdClearText_Click()

    Cls

End Sub

'This routine computes the Boltzmann factor explicitly
Private Sub cmdExplicit_Click()

    'local declarations
    'longs
    Dim Counter As Long     'iteration counter

    'doubles
    Dim P As Double
    
    'start the timer
    Starttimer = Timer

    For Counter = 1 To cNumIts
        
        'compute the Boltzmann Factor
        P = Exp(-Energy / (kvar * Temp))
    
    Next Counter
    
    'stop the timer
    Stoptimer = Timer

    'display the result
    Print "Computed exp(-E/kT) 10,000,000 times"
    Print "explitly in "; Stoptimer - Starttimer; " seconds."
    Print "Boltzmann Factor = "; P
    Print

End Sub

'This routine 'computes' the Boltzmann Factor by looking-up
'in array.
Private Sub cmdLookUp_Click()

    'local declarations
    Dim Counter As Long         'iteration counter
    Dim PIndex As Long          'lookup index for Boltzmann Factor
    
    'doubles
    Dim P As Double             'looked up Boltzmann Factor
    
    'start the timer
    Starttimer = Timer
    
    For Counter = 1 To cNumIts
        
        'compute the index
        PIndex = CLng((Energy / (kvar * Temp)) * 100)
        
        'look-up the Boltzmann Factor
        P = Expon(PIndex)
    
    Next Counter

    'stop the timer
    Stoptimer = Timer
    
    'display the result
    Print "Looked Up exp(-E/kT) 10,000,000 times "
    Print "in "; Stoptimer - Starttimer; "seconds."
    Print "Function = "; P
    Print
    
End Sub

'This routine initializes the look-up array
Private Sub Command1_Click()

    'local declarations
    Dim Counter As Long         'initialization counter

    'start the timer
    Starttimer = Timer

    For Counter = 1 To 10000
    
        'compute P(Counter/100)
        Expon(Counter) = Exp(-Counter / 100)

    Next Counter
    
    'stop the timer
    Stoptimer = Timer
    
    'display the result
    Print "Initialized Look-Up Table in "
    Print Stoptimer - Starttimer; " seconds."
    Print

End Sub

'Initialize variables needed for calculation
Private Sub Form_Load()

    Temp = 100
    Energy = 4E-21

End Sub
