VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmOther03 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Other03 -If/Then ... Bit Flag Comparison"
   ClientHeight    =   2985
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5115
   Icon            =   "Other03.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2985
   ScaleWidth      =   5115
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton Command4 
      Caption         =   "Select Type via Binary Flag Encoding"
      Enabled         =   0   'False
      Height          =   615
      Left            =   3240
      TabIndex        =   4
      Top             =   1560
      Width           =   1695
   End
   Begin MSComctlLib.ProgressBar ProgressBar1 
      Height          =   375
      Left            =   120
      TabIndex        =   3
      Top             =   240
      Visible         =   0   'False
      Width           =   2775
      _ExtentX        =   4895
      _ExtentY        =   661
      _Version        =   393216
      Appearance      =   1
   End
   Begin VB.CommandButton Command3 
      Caption         =   "Initialize Random Number Array"
      Height          =   615
      Left            =   3240
      TabIndex        =   2
      Top             =   120
      Width           =   1695
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Clear Text"
      Enabled         =   0   'False
      Height          =   615
      Left            =   3240
      TabIndex        =   1
      Top             =   2280
      Width           =   1695
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Select Type via If/Then Decisions"
      Enabled         =   0   'False
      Height          =   615
      Left            =   3240
      TabIndex        =   0
      Top             =   840
      Width           =   1695
   End
End
Attribute VB_Name = "frmOther03"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'This program demonstrates the use of binary flag encoding
'as an alternative to multiple If/Then (or If/ElseIF) decision
'statements.
'
'The particular 'application' is to select an interaction energy
'type for the pair energy in a system with three types of particles.
'In this system, there are six possible interactions arising from
'the combinations of three particles.
'
'It is assumed that the energy for 'particle 1' is being computed.
'
'The first method to select this interaction energy type, one that
'is commonly used, is to use multiple If/Then (or, as in this example,
'If/ElseIf) statements.  See the Procedure Command1_Click below.
'
'An alternative method, borrowed from a technique often used in
'system programming, is to encode the particle type in a binary
'flag structure (in this simple case, only a single LONG is used).
'With this data structure, no If/Then code structure is needed;
'the energy type is selected by simple integer addition or via
'an OR statement (as illustrated in procedure Command4_Click below).

Option Explicit

'module global declarations
'constants
Const cNumIts As Long = 50000000    'number of iterations

'integers
Dim rannum(50000000) As Integer     'using an integer rather
                                    'than LONG to save some memory
'singles
Dim starttimer As Single            'system ticks at start of loop
Dim stoptimer As Single             'system ticks at loop exit

'This procedure assigns the energy type by using a sequence
'of If/ElseIf decision statements.
Private Sub Command1_Click()

    'local declarations
    'longs
    Dim IFcounter As Long       'iteration counter
    Dim typevalue As Long       'energy type that is assigned
    
    'start the timer
    starttimer = Timer
    
    'start the loop
    For IFcounter = 2 To cNumIts
    
        'assign via If/ElseIf
        If rannum(IFcounter) = 1 And rannum(1) = 1 Then
            typevalue = 1
        ElseIf rannum(IFcounter) = 2 And rannum(1) = 1 Then
            typevalue = 3
        ElseIf rannum(IFcounter) = 4 And rannum(1) = 1 Then
            typevalue = 5
        ElseIf rannum(IFcounter) = 1 And rannum(1) = 2 Then
            typevalue = 3
        ElseIf rannum(IFcounter) = 2 And rannum(1) = 2 Then
            typevalue = 2
        ElseIf rannum(IFcounter) = 4 And rannum(1) = 2 Then
            typevalue = 6
        ElseIf rannum(IFcounter) = 1 And rannum(1) = 4 Then
            typevalue = 5
        ElseIf rannum(IFcounter) = 2 And rannum(1) = 4 Then
            typevalue = 6
        ElseIf rannum(IFcounter) = 4 And rannum(1) = 4 Then
            typevalue = 4
        End If
    
    Next IFcounter

    'stop the timer
    stoptimer = Timer
    
    'display the result
    Print
    Print cNumIts; " If/Then decisions in "
    Print stoptimer - starttimer; " seconds"
    
End Sub

'clears the screen for multiple runs
Private Sub Command2_Click()

    Cls

End Sub

'assigns the random number array...
Private Sub Command3_Click()

    'local declarations
    'longs
    Dim Counter As Long         'array assignment counter
    Dim randval As Long         'random number
    
    'show progress bar as feedback to user
    ProgressBar1.Visible = True
    
    'let Windows catch up
    DoEvents
    
    For Counter = 1 To cNumIts
    
        'get a random integer particle type: 1, 2 or 3
        randval = Int(3 * Rnd) + 1
        
        'assign random array according binary flags
        'assignment made as value = 2^(particle type-1)
        Select Case randval
        
        Case 1      'particle type 1, assign 1, or 2^0
            
            rannum(Counter) = 1
            
        Case 2      'particle type 2, assign 2, or 2^1
        
            rannum(Counter) = 2
            
        Case 3      'particle type 3, assign 4, or 2^2
        
            rannum(Counter) = 4
            
        End Select
    
        'update progress bar
        If Counter Mod (cNumIts \ 10) = 0 Then
        
            'every 10% of full job
            ProgressBar1.Value = (Counter / cNumIts) * 100
            
            'let Windows catch up
            DoEvents
            
        End If
    
    Next Counter
    
    'enable other command buttons, which are disabled on
    'startup so random array assigment must occur before
    'either of the assignment functions can be selected
    Command1.Enabled = True
    Command2.Enabled = True
    Command4.Enabled = True
    
    'hide the progress bar...no longer needed
    ProgressBar1.Visible = False

End Sub

'This procedure assigns the energy type by OR-ing
'the assigned flagged particle types.  No decision logic
'is used.
Private Sub Command4_Click()

    'local declarations
    'Longs
    Dim ORCounter As Long
    Dim typevalue As Long

    'start the timer
    starttimer = Timer
    
    For ORCounter = 2 To cNumIts
    
        'interaction type is ParticleType OR ParticleType
        typevalue = rannum(ORCounter) Or rannum(1)
    
    Next ORCounter

    'stop the timer
    stoptimer = Timer
    
    'display the results
    Print
    Print cNumIts; " binary flag OR's in "
    Print stoptimer - starttimer; " seconds."


End Sub

