//Function07.c Implementation File
//
// This program compares the stdlib function rand() to an inline, handrolled 
// psuedo random number generator.
//
// The intrinsic function (in stdlib) is called from fnA()
// The inline generator is in fnB()

#include <windows.h>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>

//defines
#define NumIts 50000000		//number of iterations

//functions
void fnIntrinsic();			//uses intrinsic rand()
void fnHandRolled();		//uses hand rolled generator

//global declarations
int xk;					//'last' random number generated

//computes random numbers from stdlib rand() function
void fnIntrinsic()
{

	//local declarations
	//integers
	int i;			//iteration counter
	int rnum;		//random number
	
	//doubles
	double ElapsedTime;	//ticks during loop
	double t1;		//ticks at start of loop
	double t2;		//ticks at loop end	
	
	//display entry message
	printf("\nGetting Random Numbers with Intrinsic function...\n");
	
	//get start time
	t1 = GetTickCount();
	
	for(i=1; i<= NumIts; ++i){
	
		//get next random number in sequence
		rnum = rand();


	}
	
	//stop the timer
	t2 = GetTickCount();

	//compute the elapsed time
	ElapsedTime = (t2 - t1) * 0.001;

	//display the result
	printf("%s%g%s", "\nElapsed Time = ", ElapsedTime, " seconds\n\n");
	
}//end fnIntrinsic()

void fnHandRolled()
{

	//local declarations
	//integers
	int i;			//iteration counter
	int rnum;		//a pseudo random number
	
	//doubles
	double ElapsedTime;	//ticks during loop
	double t1;		//ticks at start of loop
	double t2;		//ticks at loop end
	
	//seed the generator
	xk = 200;
	
	//display entry message
	printf("\nGetting Random Numbers with Hand Rolled Generator...\n");
	
	//get start time
	t1 = GetTickCount();
	
	for(i=1; i<= NumIts; ++i){
	
		//compute the next pseudo random number
		//in the sequence
		rnum = (25 * xk) % 16777216;
		
		//increment the recursive index
		xk = rnum;
		
	}
	
	//stop the timer
	t2 = GetTickCount();
	
	//compute the elapsed time
	ElapsedTime = (t2 - t1) * 0.001;

	//display the result
	printf("%s%g%s", "\nElapsed Time = ", ElapsedTime, " seconds\n\n");
	
}//end fnHandRolled()

//entry function
int main()
{
	//local declarations
	//integers
	int bTERM;		//menu flag

	//character strings
	char inchar;		//input character
	

	//initialize bTERM to NOT TERMINATE
	bTERM = 0;
	
	//clear terminal
	system("cls");
	
	do {
		
		//present menu to user
		printf("Enter the Number of the routine to run, and press <Enter> \n");
		printf("1\tUse Intrinsic rand() function\n");
		printf("2\tUse Hand-Rolled Generator\n");
		printf("q\tEnd this program\n");
	
		//get user input
		scanf("%s", &inchar);

		//inchar = getchar();

		//call the user selected function
		switch	(inchar){

			case '1': fnIntrinsic();
				break;
	
			case '2': fnHandRolled();
				break;
		
			//select the terminate function	
			case 'q': printf("Ending This Program\n");
				
				//set flag to terminate
				bTERM = 1;
				break;

		}
		
	} while(!bTERM);

	return 0;

}
