// Data01Dlg.cpp : implementation file
//
// This program compares code requiring type conversions to that
// with properly typed variables.

#include "stdafx.h"
#include "Data01.h"
#include "Data01Dlg.h"
#include "stdio.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//global declarations
const int cNumIts = 10000000;

/////////////////////////////////////////////////////////////////////////////
// CData01Dlg dialog

CData01Dlg::CData01Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CData01Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CData01Dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CData01Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CData01Dlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CData01Dlg, CDialog)
	//{{AFX_MSG_MAP(CData01Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CData01Dlg message handlers

BOOL CData01Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CData01Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CData01Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// computes x^y with poor declarations that force type conversions
void CData01Dlg::OnButton1() 
{
	
	//local declarations
	//integers
	int counter;
	int j;
	int x;
	int y;
	int result;

	//doubles
	double starttime;
	double stoptime;
	double ElapsedTime;

	//character strings
	char buffer[200];
	
	//assign base
	x = (int)2;

	//start the timer
    starttime = GetTickCount();

	//assign exponent
	y = (int)4;
    
	for(counter=1; counter <=cNumIts; ++counter){
        
		//compute x^y
		result = (int)pow((double)y, (double)x);
    
    }
    
	//stop the timer
    stoptime = GetTickCount();
    
	//compute the elapsed time
	ElapsedTime = (stoptime - starttime) * 0.001;
	
	//build the output string and display result in message box
	j = sprintf(buffer,"%s%d%s%g", "Computed x^y ", cNumIts, " times with three mismatches in ",ElapsedTime);
	j += sprintf(buffer + j, "%s"," seconds.\n");
	j += sprintf(buffer + j, "%s%d", "Result = ", result);

	MessageBox(buffer,
					 "x^y with type mismatches",
					 MB_OK | MB_ICONEXCLAMATION);
	
}

//compute x^y with properly typed data
void CData01Dlg::OnButton2() 
{
	//local declarations
	//integers
	int counter;
	int j;

	//doubles
	double x;
	double y;
	double result;
	double starttime;
	double stoptime;
	double ElapsedTime;

	//character strings
	char buffer[200];
	
	//assign base
	x = 2;

	//start the timer
    starttime = GetTickCount();

	//assign exponent
	y = (double)4;
    
	for(counter=1; counter <=cNumIts; ++counter){
        
		//compute x^y
		result = pow(y, x);
    
    }
    
	//stop the timer
    stoptime = GetTickCount();
    
	//compute elapsed time
	ElapsedTime = (stoptime - starttime) * 0.001;
	
	//build output string and display result in message box
	j = sprintf(buffer,"%s%d%s%g", "Computed x^y ", cNumIts, " times without mismatches in ",ElapsedTime);
	j += sprintf(buffer + j, "%s"," seconds.\n");
	j += sprintf(buffer + j, "%s%g", "Result = ", result);

	MessageBox(buffer,
					 "x^y with no type mismatches",
					 MB_OK | MB_ICONEXCLAMATION);	
}
