// Data02Dlg.cpp : implementation file
//
// This program explores the data typing of loop counters.  In general,
// it is assumed that loop counters should be 32 bit integers (on
// 32 bit machines with 32 bit OS's). 
//
// To illustrate this, y=sin(x) is computed at 0.01 degree increments.
// Since the sin() function takes a double arguement in radians.
//
// There are four demos in this program:
//
//		1.	The loop is done in degrees with a double counter
//		2.	The loop is done in degrees with an integer counter
//		3.	The loop is done in radians with a double counter
//		4.	The loop is done in radians with an integer counter


#include "stdafx.h"
#include "Data02.h"
#include "Data02Dlg.h"
#include "stdio.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// Global Declarations

int cNumIts = 1000;		//number of iterations

double cDeg2Rad = 0.017453292;  //Pi/180 to convert degrees to radians
double ccDeg2Rad = 0.00017453292;   //0.01 degrees in radians
double c2Pi = 6.283185307;      //2 * Pi
double cDegStep = 0.01;         //Degree step size, the 'precision' we wish
                                //to compute sin(angle)
double cRadStep = 0.00001;      //Converts the radian LONG to Double in Meth4



/////////////////////////////////////////////////////////////////////////////
// CData02Dlg dialog

CData02Dlg::CData02Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CData02Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CData02Dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CData02Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CData02Dlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CData02Dlg, CDialog)
	//{{AFX_MSG_MAP(CData02Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDMethod1, OnMethod1)
	ON_BN_CLICKED(IDMethod2, OnMethod2)
	ON_BN_CLICKED(IDMethod3, OnMethod3)
	ON_BN_CLICKED(IDMethod4, OnMethod4)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CData02Dlg message handlers

BOOL CData02Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CData02Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CData02Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//computes y=sin(x) using int counter loop in degrees
void CData02Dlg::OnMethod1() 
{

	//local declarations
	//integers
	int counter;			//counter for variable 'x'
	int ItCounter;			//iteration counters
	int j;					//output string pointer

	//doubles
	double starttime;		//ticks at start of loop
	double stoptime;		//ticks at loop exit
	double dummy;			//return value for sin(x), not needed for demo
	double ElapsedTime;		//ticks during loop

	//character strings
	char buffer[200];		//output string
	
	//start the timer
    starttime = GetTickCount();

    for(ItCounter=1; ItCounter <=cNumIts; ++ItCounter){
        
		//using integer loop counter
		//compute y=sin(x), 0-360 degrees in 0.01 degree increments
        for(counter=0; counter <=36000; ++counter){ 
		
            //sin() gets double arg
            dummy = sin((double)counter * ccDeg2Rad);				 
        
        }
    
    }
    
	//stop the timer
    stoptime = GetTickCount();
    
	//compute the elapsed time
	ElapsedTime = (stoptime - starttime) * 0.001;
	
	//build the output string and display in message box
	j = sprintf(buffer,"Computed y=sin(x) 1000 times using INT loop counter in degrees %g ",ElapsedTime);
	j += sprintf(buffer + j, "%s"," seconds.");

	MessageBox(buffer,
					 "INT Loop counter in Degrees",
					 MB_OK | MB_ICONEXCLAMATION);

}

//computes y=sin(x) using double loop counter in degrees
void CData02Dlg::OnMethod2() 
{

	//local declarations
	//integers
	int ItCounter;					//iteration counter
	int j;							//output string pointer

	//doubles
    double x;						//value of x, in degrees
	double starttime;				//ticks at start of loop
	double stoptime;				//ticks at loop exit
	double dummy;					//return value for sin(x), not needed for demo
	double ElapsedTime;				//ticks during loop

	//character strings
	char buffer[200];				//output string
	
	//start the timer
    starttime = GetTickCount();

    for(ItCounter=1; ItCounter <= cNumIts; ++ItCounter){
        
        //using double loop counter
		//compute y=sin(x), 0-360 degrees in 0.01 degree increments
		for(x=0; x <=360; x = x + 0.01){ 
		
			//sin() gets double arg
            dummy = sin(x * cDeg2Rad);		
        
        }
    
    }
    
	//stop the timer
    stoptime = GetTickCount();
    
	//compute the elapsed time
	ElapsedTime = (stoptime - starttime) * 0.001;
	
	//build the output string and display in a message box
	j = sprintf(buffer,"Computed y=sin(x) 1000 times using DOUBLE loop counter in degrees %g ",ElapsedTime);
	j += sprintf(buffer + j, "%s"," seconds.");

	MessageBox(buffer,
					 "DOUBLE Loop counter in Degrees",
					 MB_OK | MB_ICONEXCLAMATION);



}

//computes y=sin(x) using double loop counter in radians
void CData02Dlg::OnMethod3() 
{

	//local declarations
	//integers
	int ItCounter;				//iteration counter
	int j;						//output string pointer

	//doubles
	double arg1;				//argument to sin(x), in radians
	double starttime;			//ticks at start of loop
	double stoptime;			//ticks at loop exit
	double dummy;				//return value for sin(x), not needed for demo
	double ElapsedTime;			//ticks during loop

	//character strings
	char buffer[200];			//output string
	
	//start the timer
    starttime = GetTickCount();

    for(ItCounter=1; ItCounter <= cNumIts; ++ItCounter){

        //using double loop counter
		//compute y=sin(x), 0-360 degrees in 0.01 degree increments
		//the argument counter is in radians
        for(arg1=0; arg1 <= c2Pi; arg1 = arg1 + ccDeg2Rad){ 
		
			//sin() gets double arg
            dummy = sin(arg1);				 
        
        }
    
    }
    
	//stop the timer
    stoptime = GetTickCount();
    
	//compute elapsed time
	ElapsedTime = (stoptime - starttime) * 0.001;
	
	//build the output string and display in a message box
	j = sprintf(buffer,"Computed y=sin(x) 1000 times using DOUBLE loop counter in radians %g ",ElapsedTime);
	j += sprintf(buffer + j, "%s"," seconds.");

	MessageBox(buffer,
					 "DOUBLE Loop counter in Radians",
					 MB_OK | MB_ICONEXCLAMATION);



}

//computes y=sin(x) using int loop counter in radians
void CData02Dlg::OnMethod4() 
{

	//local declarations
	//integers
	int counter;				//x value for sin(x)
	int ItCounter;				//iteration counter
	int j;						//output string pointer

	//doubles
	double starttime;			//ticks at start of loop
	double stoptime;			//ticks at loop exit
	double dummy;				//return value for sin(x), not needed for demo
	double ElapsedTime;			//ticks during loop

	//character strings
	char buffer[200];			//output string

	//start the timer
    starttime = GetTickCount();

    for(ItCounter=1; ItCounter <=cNumIts; ++ItCounter){
		
		//using integer loop counter
		//compute y=sin(x), 0-360 degrees in 0.01 degree increments
		//the argument counter is in radians
		for(counter=0; counter <= 62831853; counter=counter+1745){ 
		
            //sin() gets double arg
            dummy = sin((double)counter * ccDeg2Rad);				 
        
        }
    
    }
    
	//stop the timer
    stoptime = GetTickCount();
    
	//compute elapsed time
	ElapsedTime = (stoptime - starttime) * 0.001;
	
	//build the output string and display result in message box
	j = sprintf(buffer,"Computed y=sin(x) 1000 times using INT loop counter in radians %g ",ElapsedTime);
	j += sprintf(buffer + j, "%s"," seconds.");

	MessageBox(buffer,
					 "INT Loop counter in Radians",
					 MB_OK | MB_ICONEXCLAMATION);


}
