// Data03Dlg.cpp : implementation file
//
//
// This program demonstrates the performance difference between using
// variable data and 'constant' data.  The variables generally force
// a memory reference compared to the immediate data reference possible
// with constants.
//
// In C, immediate data are generally declared as macros, using #define. 
//
// This demo uses an empty for loop that is executed repeatedly.  Getting
// machine/platform uniform data in this demo may be difficult do to
// data caching.

#include "stdafx.h"
#include "Data03.h"
#include "Data03Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define CSTART 1
#define CSTOP   20
#define CSTEPSIZE   1

//global declarations
const int cStart = 1;            //immediate loop start
const int cStop = 20;            //immediate loop stop
const int cStepSize = 1;         //immediate loop step
const int cNumIts = 10000000;    //number of iterations

//integers
int StartCounter;            //memory loop start
int StopCounter;             //memory loop stop
int StepSize;                //memory loop step size
int Counter;                 //test loop counter

/////////////////////////////////////////////////////////////////////////////
// CData03Dlg dialog

CData03Dlg::CData03Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CData03Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CData03Dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CData03Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CData03Dlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CData03Dlg, CDialog)
	//{{AFX_MSG_MAP(CData03Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CData03Dlg message handlers

BOOL CData03Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CData03Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CData03Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// repeatedly do a for loop with memory references as loop boundaries
void CData03Dlg::OnButton1() 
{
	//local declarations
	//integers
	int j;						//output string pointer
	int itcounter;				//iteration counter

	//doubles
	double starttime;			//system 'ticks' at start of loop
	double stoptime;			//system 'ticks' at loop exit
	double ElapsedTime;			//system ticks during loop

	//character strings
	char buffer[200];			//output string

	//start the timer
    starttime = GetTickCount();

	//initialize the data
	StartCounter = CSTART;
	StopCounter = CSTOP;
	StepSize = CSTEPSIZE;

	for(itcounter=1; itcounter <= cNumIts; ++itcounter){
        
		for(Counter=StartCounter; Counter <= StopCounter; Counter = Counter + StepSize){ 

		}
    
    }
    
	//stop the timer
    stoptime = GetTickCount();
    
	//compute elapsed time
	ElapsedTime = (stoptime - starttime) * 0.001;
	
	//build output string and display result in message box
	j = sprintf(buffer,"%s%d%s%g", "Looped 1-20 ", cNumIts, " times with memory references in ",ElapsedTime);
	j += sprintf(buffer + j, "%s"," seconds.\n");

	MessageBox(buffer,
					 "Memory References as Loop Bounds",
					 MB_OK | MB_ICONEXCLAMATION);	
}

//repeatedly do for loop with immediate data as loop boundaries
void CData03Dlg::OnButton2() 
{
	//local declarations
	//integers
	int j;						//output string pointer
	int itcounter;				//iteration counter

	//doubles
	double starttime;			//system 'ticks' at start of loop
	double stoptime;			//system 'ticks' at loop exit
	double ElapsedTime;			//system ticks during loop

	//character strings
	char buffer[200];			//output string

	//start the timer
    starttime = GetTickCount();

	for(itcounter=1; itcounter <= cNumIts; ++itcounter){
        
		for(Counter=CSTART; Counter <= CSTEPSIZE; Counter = Counter + CSTEPSIZE){ 

		}
    
    }
    
	//stop the timer
    stoptime = GetTickCount();
    
	//compute elapsed time
	ElapsedTime = (stoptime - starttime) * 0.001;
	
	//build output string and display result in message box
	j = sprintf(buffer,"%s%d%s%g", "Looped 1-20 ", cNumIts, " times with immediate references in ",ElapsedTime);
	j += sprintf(buffer + j, "%s"," seconds.\n");

	MessageBox(buffer,
					 "Immediate References as Loop Bounds",
					 MB_OK | MB_ICONEXCLAMATION);	
}
