// Data06Dlg.cpp : implementation file
//
// This program extracts the four byte raw data from a floating
// point value.  The API CopyMemory function is used to access the
// data.
//
// This type of routine may be useful when floating point data must
// be sent over a network.
//
// The working code is in CData06Dlg::OnButton1().

#include "stdafx.h"
#include "Data06.h"
#include "Data06Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/////////////////////////////////////////////////////////////////////////////
// CData06Dlg dialog

CData06Dlg::CData06Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CData06Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CData06Dlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CData06Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CData06Dlg)
	DDX_Control(pDX, IDC_EDIT2, m_edit2);
	DDX_Control(pDX, IDC_EDIT1, m_edit1);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CData06Dlg, CDialog)
	//{{AFX_MSG_MAP(CData06Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_EN_CHANGE(IDC_EDIT1, OnChangeEdit1)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CData06Dlg message handlers

BOOL CData06Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CData06Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CData06Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CData06Dlg::OnChangeEdit1() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	
	// TODO: Add your control notification handler code here
	
}

// extracts the four bytes of raw data from a floating point variable
void CData06Dlg::OnButton1() 
{

	//local declarations
	// integers
	int j;							// output string pointer
	int i;							// another output string pointer

	// floats
	float x;						// the float to convert

	//character strings
	char edit1text[10];				// contents of edit box 1
	char edit2text[4];				// contents of edit box 2
	char *notneeded;				// would be the stopstring if needed
	char buffer[200];				// output string for messagebox

	unsigned char byte1[4];			//unsigned so we are getting raw data
	
	// get the string contents of edit box 1
	m_edit1.GetLine(0, edit1text );

	// convert the string contents to a floating point value
	x = (float)strtod( edit1text, &notneeded );

	// raw copy four bytes into byte array
	CopyMemory(&byte1[0], &x,4);

	// build the first line of the message box text
	j = sprintf(buffer, "x = %f", x);

	// build edit box 2 text
	i = sprintf(edit2text, "%.2hX %.2hX %.2hX %.2hX %s", byte1[3], byte1[2], byte1[1], byte1[0], " H");

	// build second line of message box text
	// this verifies that the length of the string is always four bytes,
	// even for a float value like 1.23456
	j=+ sprintf(buffer + j, "%s %u", " \nBytes in string = ", sizeof(edit2text));

	// display the message box
	MessageBox(buffer, "Edit Box Text",
				MB_OK | MB_ICONEXCLAMATION);
	
	// write the output, in hex, to edit box 2
	m_edit2.SetWindowText(edit2text);

}
