// Function02Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "Function02.h"
#include "Function02Dlg.h"
#include "math.h"
#include "stdio.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// global declarations
static int cNumIts = 10000000;

// functions
double calc_ljenergyRef(double *Rptr);
double calc_ljenergyVal(double R);

/////////////////////////////////////////////////////////////////////////////
// CFunction02Dlg dialog

CFunction02Dlg::CFunction02Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFunction02Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFunction02Dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFunction02Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFunction02Dlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CFunction02Dlg, CDialog)
	//{{AFX_MSG_MAP(CFunction02Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFunction02Dlg message handlers

BOOL CFunction02Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CFunction02Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CFunction02Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


//LJ Energy function call by passing distance value, r
void CFunction02Dlg::OnButton1() 
{
	
	    //Local Declarations
	//Integers
	int counter;
	int j;

	//doubles
    double starttime;         //system ticks at start of loop
    double stoptime;          //system ticks at end of loop
    double ElapsedTime;	   	  //system ticks during loop
	double r;                 //distance, a double to pass to function
    double energy;            //energy, holder for function return value
    
	//characters
	char buffer[200];		//output string


    r = 1.234;                           //just a value to pass
    
    starttime = GetTickCount();		//start the timer

	for(counter=1; counter <= cNumIts; ++counter){
    

        energy = calc_ljenergyVal(r);   //call the function, passing a double and
                                     //returning a double

    }
    
    stoptime = GetTickCount();      //stop the timer
    
    
    //compute the elapsed time, in seconds
    ElapsedTime = (stoptime - starttime) * .001;

	//display the result in a message box
	j=sprintf(buffer, "Repeatedly called function passing a value 10,000,000 times in %g", ElapsedTime);
	j += sprintf(buffer + j, "%s", " seconds.\n");
	j += sprintf(buffer + j, " Energy = %g", energy);

	MessageBox(buffer, "Done with Function Calls",
				MB_OK | MB_ICONEXCLAMATION);
	

	
}


//LJ Energy function call by passing reference to distance, r
void CFunction02Dlg::OnButton2() 
{

	    //Local Declarations
	//Integers
	int counter;
	int j;
	

	//doubles
    double starttime;         //system ticks at start of loop
    double stoptime;          //system ticks at end of loop
    double ElapsedTime;	   	  //system ticks during loop
	double r;                 //distance, a double to pass to function
    double energy;            //energy, holder for function return value
    
	//characters
	char buffer[200];		//output string


    r = 1.234;                           //just a value to pass
    
    starttime = GetTickCount();		//start the timer

	for(counter=1; counter <= cNumIts; ++counter){
    

		//rptr = &r;
        energy = calc_ljenergyRef(&r);   //call the function, passing a reference and
										 //returning a double

    }
    
    stoptime = GetTickCount();      //stop the timer
    
    
    //compute the elapsed time, in seconds
    ElapsedTime = (stoptime - starttime) * .001;

	//display the result in a message box
	j=sprintf(buffer, "Repeatedly called function passing a reference 10,000,000 times in %g", ElapsedTime);
	j += sprintf(buffer + j, "%s", " seconds.\n");
	j += sprintf(buffer + j, " Energy = %g", energy);

	MessageBox(buffer, "Done with Function Calls",
				MB_OK | MB_ICONEXCLAMATION);
	


}


//LJ Energy calculation done inline, without any function call
void CFunction02Dlg::OnButton3() 
{

	    //Local Declarations
	//Integers
	int counter;
	int j;

	//doubles
    double starttime;         //system ticks at start of loop
    double stoptime;          //system ticks at end of loop
    double ElapsedTime;	   	  //system ticks during loop
	double r;                 //distance, a double to pass to function
    double r1;
	double r2;
	double energy;            //energy, holder for function return value
    
	//characters
	char buffer[200];		//output string


    r = 1.234;                           //just a value to pass
    
    starttime = GetTickCount();		//start the timer

	for(counter=1; counter <= cNumIts; ++counter){
    

        r1 = r * r * r * r * r * r;
		r2 = r1 * r1;

		energy = 1/r2 - 1/r1;

    }
    
    stoptime = GetTickCount();      //stop the timer
    
    
    //compute the elapsed time, in seconds
    ElapsedTime = (stoptime - starttime) * .001;

	//display the result in a message box
	j=sprintf(buffer, "Using Inline Code, computed E 10,000,000 times in %g", ElapsedTime);
	j += sprintf(buffer + j, "%s", " seconds.\n");
	j += sprintf(buffer + j, " Energy = %g", energy);

	MessageBox(buffer, "Done with Function Calls",
				MB_OK | MB_ICONEXCLAMATION);
	


}

double calc_ljenergyVal (double R)
{

	double R1;		//used internally in the 
	double R2;		//optimized lj energy computation
	double En;		//Energy

	R1 = R * R * R * R * R * R;
	R2 = R1 * R1;

	En = 1/R2 - 1/R1;

	return (En);

}

double calc_ljenergyRef (double *Rptr)
{

	double R1;		//used internally in the 
	double R2;		//optimized lj energy computation
	double En;

	R1 = *Rptr;
	R1 = R1 * R1 * R1 * R1 * R1 * R1;
	R2 = R1 * R1;

	En = 1/R2 - 1/R1;

	return (En);

}
