// Function05Dlg.cpp : implementation file
//
// This program demonstrates the use of global data rather than passing
// parameters to functions.  No work is done in the computational
// functions

#include "stdafx.h"
#include "Function05.h"
#include "Function05Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// global declarations
static int cNumIts = 50000000;		//number of iterations

double gR;		//global distance
double gE;		//global energy

// functions
//receives reference
double calc_ljenergyRef(double *Rptr);

//receives value
double calc_ljenergyVal(double R);

//"works" on global data
int calc_ljenergyglobal();

/////////////////////////////////////////////////////////////////////////////
// CFunction05Dlg dialog

CFunction05Dlg::CFunction05Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFunction05Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFunction05Dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFunction05Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFunction05Dlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CFunction05Dlg, CDialog)
	//{{AFX_MSG_MAP(CFunction05Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFunction05Dlg message handlers

BOOL CFunction05Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CFunction05Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CFunction05Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

//call by passing a single double value
void CFunction05Dlg::OnButton1() 
{
	//Local Declarations
	//Integers
	int counter;			//iteration counter
	int j;					//output string pointer

	//doubles
    double starttime;         //system ticks at start of loop
    double stoptime;          //system ticks at end of loop
    double ElapsedTime;	   	  //system ticks during loop
	double r;                 //distance, a double to pass to function
    double energy;            //energy, holder for function return value
    
	//characters
	char buffer[200];		//output string

	//just a value to pass
    r = 1.234;      
	
    //start the timer
    starttime = GetTickCount();		

	for(counter=1; counter <= cNumIts; ++counter){
    
		//call the function, passing a double and
        //returning a double
        energy = calc_ljenergyVal(r);   

    }
    
	//stop the timer
    stoptime = GetTickCount();      
     
    //compute the elapsed time, in seconds
    ElapsedTime = (stoptime - starttime) * .001;

	//display the result in a message box
	j=sprintf(buffer, "Repeatedly called function passing a value 50,000,000 times in %g", ElapsedTime);
	j += sprintf(buffer + j, "%s", " seconds.\n");

	MessageBox(buffer, "Done with Function Calls",
				MB_OK | MB_ICONEXCLAMATION);
	

	
}

//calls the function passing a reference
void CFunction05Dlg::OnButton2() 
{
		//Local Declarations
	//Integers
	int counter;			//iteration counter
	int j;					//output string pointer

	//doubles
    double starttime;         //system ticks at start of loop
    double stoptime;          //system ticks at end of loop
    double ElapsedTime;	   	  //system ticks during loop
	double r;                 //distance, a double to pass to function
	double *rptr;			  //pointer to r
	double energy;            //energy, holder for function return value
    
	//characters
	char buffer[200];		//output string

	//just a value to pass
    r = 1.234;

	rptr = &r;
	
    //start the timer
    starttime = GetTickCount();		

	for(counter=1; counter <= cNumIts; ++counter){
    
		//call the function, passing a refence and
        //returning a double
        energy = calc_ljenergyRef(rptr);   

    }
    
	//stop the timer
    stoptime = GetTickCount();      
     
    //compute the elapsed time, in seconds
    ElapsedTime = (stoptime - starttime) * .001;

	//display the result in a message box
	j=sprintf(buffer, "Repeatedly called function passing a reference 50,000,000 times in %g", ElapsedTime);
	j += sprintf(buffer + j, "%s", " seconds.\n");

	MessageBox(buffer, "Done with Function Calls",
				MB_OK | MB_ICONEXCLAMATION);

	
}


//calls the function that uses global data
void CFunction05Dlg::OnButton3() 
{
		//Local Declarations
	//Integers
	int counter;			//iteration counter
	int j;					//output string pointer
	int dummy;				//return value

	//doubles
    double starttime;         //system ticks at start of loop
    double stoptime;          //system ticks at end of loop
    double ElapsedTime;	   	  //system ticks during loop

	//characters
	char buffer[200];		//output string

	//just a value to pass
    gR = 1.234;      
	
    //start the timer
    starttime = GetTickCount();		

	for(counter=1; counter <= cNumIts; ++counter){
    
		//call the function, using global data and
        //returning an integer (say a success code)
        dummy = calc_ljenergyglobal();   

    }
    
	//stop the timer
    stoptime = GetTickCount();      
     
    //compute the elapsed time, in seconds
    ElapsedTime = (stoptime - starttime) * .001;

	//display the result in a message box
	j=sprintf(buffer, "Repeatedly called function passing global data 50,000,000 times in %g", ElapsedTime);
	j += sprintf(buffer + j, "%s", " seconds.\n");

	MessageBox(buffer, "Done with Function Calls",
				MB_OK | MB_ICONEXCLAMATION);

	
}

//receives the data value
double calc_ljenergyVal (double R)
{

	double En;

	En = R;

	return (0);

}

//receives the data reference
double calc_ljenergyRef (double *Rptr)
{

	double En;

	En = *Rptr;

	return (En);

}

int calc_ljenergyglobal()
{

	gE = gR;

	return(0);

}