//////////////////// Matrix Implementation //////////////////////////
//                                                                 //
//                   x87 based Matrix Routines                     //
//                                                                 //
//  Written by:  John S. Riley                                     //
//                                                                 //
//  This file contains a variety of matrix manipulation routines   //
//  written for generic x87 floating-point processors.             //
//                                                                 //
//  The routines use no explicit SIMD instructions, but may be     //
//  compiled using compiler generated SSE or 3dNow instructions.   //
//                                                                 //
//  The matrix routines use unrolled loops.  Matrix dimension	   //
//	and data are passed to the functions as parameters (data or	   //
//	pointers).								                       //
//                                                                 //
/////////////////////////////////////////////////////////////////////

///////////////////////// INCLUDES //////////////////////////////////

#include "Matrix.h"
#include "stdlib.h"
#include "math.h"

///////////////////////// FUNCTIONS /////////////////////////////////