///////////////////// TestLib Implementation File ////////////////////
//																	//
//	This program is to test the library functions.  				//
//																	//
//////////////////////////////////////////////////////////////////////

//////////////////////////// INCLUDES ////////////////////////////////

#include "stdio.h"
#include "genMath.h"

////////////////////////////// MAIN //////////////////////////////////
void main()
{

	//local declarations
	//integers
	int i;				// dimension counter
	int retcode;		// return code for call to genGausSeidel

	//floats
	float a[3][3];			// matrix A
	float b[3];				// vector b
	float t[3];				// initial guess vector t; solution is
							// returned here as well

	//character strings
	char  ch;				//input string to exit

	//intialize the A matrix and b vector
	a[0][0] = (float)6;
	a[0][1] = (float)1;
	a[0][2] = (float)1;

	a[1][0] = (float)1;
	a[1][1] = (float)9;
	a[1][2] = (float)-2;

	a[2][0] = (float)2;
	a[2][1] = (float)-1;
	a[2][2] = (float)8;

	b[0] = (float)10.7;
	b[1] = (float)3.6;
	b[2] = (float)12.1;

	//initialize initial guess for t vector
	t[0] = (float)1;
	t[1] = (float)1;
	t[2] = (float)1;


	//call the solver
	retcode = genGaussSeidel(&a[0][0],t,b,3, (float)0.00001);

	
	//display the result
	
	printf("%s", "System Solved using Gauss Seidel: \n\n");

	for(i=0;i<=2;++i){
	
		printf("%s%d%s%f%s", "t[",i,"] = ", t[i],"\n");
	
	}

	printf("%s","\n");

	printf("%s%d%s", "Iterations to converge: ", retcode, "\n\n");

	//display closing message and wait for <enter> before exiting
	printf("Press <Enter> to end");
	scanf("%c", &ch);

} // End Main


